function im = pgmread(filename)
% usage:
%      out_image = pgmread(filename)
% read a raw image file of size m x n from the file "filename"
fid = fopen(filename);
% read magic number
line = fgets(fid);
mno = sprintf('%s',line(1:2));
if (strcmp(mno,'P5'))
	% PGM file
	% skip comment lines
	line = fgets(fid);
	while (strcmp(line(1),'#'))
		line = fgets(fid);
	end
	% read width and height
	dimensions = sscanf(line,'%d %d');
	w = dimensions(1);
	h = dimensions(2);
	line = fgets(fid);
	maxval = sscanf(line,'%d');
	x = fread(fid,[w,h],'uchar');
	im = x'; % return transpose to turn into row column format
else 
	if (strcmp(mno,'P2'))
		% ascii pgm file.
		% skip comment lines
		line = fgets(fid);
		while (strcmp(line(1),'#'))
			line = fgets(fid);
		end
		% read width and height
		dimensions = sscanf(line,'%d %d');
		w = dimensions(1);
		h = dimensions(2);
		line = fgets(fid);
		maxval = sscanf(line,'%d');
		[x count] = fscanf(fid,'%d',[w,h]);
		if (count == w*h)
			im = x'; % return transpose
		end
	end
end




